# Replacement Values

### Overview

The BlueFletch Launcher supports a variety of replacement variables, or values that can be utilized by widgets, custom intents, layout items, and custom fields. These variables act as placeholders for actual values stored in the referenced location. This is a list of the supported values, which fall within the categories of Device, Session, and Extended attributes.

### Device Attributes

* **${device.*****key\_name\_here*****}**
* Includes:
  * device.MODEL
  * device.BRAND
  * device.MANUFACTURER
  * device.HARDWARE
  * device.SDK\_INT
  * device.SECURITY\_PATCH

### Session Attributes

All Extended Attributes from session object are available as:

* **${session.ex.*****key\_name\_here*****}**
* Example: ${session.ex.accessToken}

Main session attributes:

* **${session.*****key\_name\_here*****}**
* Includes:
  * session.userId
  * session.userName
  * session.role
  * session.groups
  * session.location
  * session.extension
  * session.session\_idle
  * ssession.session\_max
  * session.retain\_session\_oncradle
  * session.logout

### Extended Attributes

* **${config.ex.*****key\_name\_here*****}**
* Includes by default:
  * config.ex.siteId
  * config.ex.deviceId
    * To add device ID to the header

      ```json
          "customField": {
              "format": "${config.ex.deviceId}"
          },
      ```
  * config.ex.phoneNumber
    * starting in Launcher version 3.26.24
  * Other key-value strings can be added to the `extendedAttributes` object in the the launcher.json.
* Any columns added to the sitelist.csv become extended attributes:
  * config.ex.*COLUMN\_NAME*


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/configurable-layouts/replacement-values.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
